searchNodes=[{"ref":"XmerlC14n.html","title":"XmerlC14n","type":"module","doc":"Elixirification of esaml&#39;s Erlang xmerl_c14n implementation. Functions for performing XML canonicalization (c14n), as specified at http://www.w3.org/TR/xml-c14n These routines work on xmerl data structures (see the xmerl user guide for details)."},{"ref":"XmerlC14n.html#canonicalize/1","title":"XmerlC14n.canonicalize/1","type":"function","doc":"Given an xmerl XML tuple (element/attribute/etc...), returns the canonical binary version of the XML it represents. Returns either {:ok, String.t()} if canonicalized successfully, or {:error, {:failed_canonicalization, term}} if canonicalization failed. If the preserve_comments argument is true, preserves comments in the output. Any namespace prefixes listed in inclusive_namespaces will be left as they are and not modified during canonicalization. # Given xml &lt;!DOCTYPE doc [&lt;!ATTLIST e9 attr CDATA &quot;default&quot;&gt;]&gt; &lt;doc&gt; &lt;e1 /&gt; &lt;e2 &gt;&lt;/e2&gt; &lt;e3 name = &quot;elem3&quot; id=&quot;elem3&quot; /&gt; &lt;e4 name=&quot;elem4&quot; id=&quot;elem4&quot; &gt;&lt;/e4&gt; &lt;e5 a:attr=&quot;out&quot; b:attr=&quot;sorted&quot; attr2=&quot;all&quot; attr=&quot;I&#39;m&quot; xmlns:b=&quot;http://www.ietf.org&quot; xmlns:a=&quot;http://www.w3.org&quot; xmlns=&quot;http://example.org&quot;/&gt; &lt;e6 xmlns=&quot;&quot; xmlns:a=&quot;http://www.w3.org&quot;&gt; &lt;e7 xmlns=&quot;http://www.ietf.org&quot;&gt; &lt;e8 xmlns=&quot;&quot; xmlns:a=&quot;http://www.w3.org&quot;&gt; &lt;e9 xmlns=&quot;&quot; xmlns:a=&quot;http://www.ietf.org&quot;/&gt; &lt;/e8&gt; &lt;/e7&gt; &lt;/e6&gt; &lt;/doc&gt; iex&gt; {doc, _} = xml |&gt; to_charlist |&gt; :xmerl_scan.string(namespace_conformant: true, document: true) iex&gt; {:ok, canonicalized_xml} = XmerlC14n.canonicalize(doc) iex&gt; IO.puts(canonicalized_xml) &lt;doc&gt; &lt;e1&gt;&lt;/e1&gt; &lt;e2&gt;&lt;/e2&gt; &lt;e3 id=&quot;elem3&quot; name=&quot;elem3&quot;&gt;&lt;/e3&gt; &lt;e4 id=&quot;elem4&quot; name=&quot;elem4&quot;&gt;&lt;/e4&gt; &lt;e5 xmlns=&quot;http://example.org&quot; xmlns:a=&quot;http://www.w3.org&quot; xmlns:b=&quot;http://www.ietf.org&quot; attr=&quot;I&#39;m&quot; attr2=&quot;all&quot; b:attr=&quot;sorted&quot; a:attr=&quot;out&quot;&gt;&lt;/e5&gt; &lt;e6&gt; &lt;e7 xmlns=&quot;http://www.ietf.org&quot;&gt; &lt;e8 xmlns=&quot;&quot;&gt; &lt;e9&gt;&lt;/e9&gt; &lt;/e8&gt; &lt;/e7&gt; &lt;/e6&gt; &lt;/doc&gt;"},{"ref":"XmerlC14n.html#canonicalize/2","title":"XmerlC14n.canonicalize/2","type":"function","doc":""},{"ref":"XmerlC14n.html#canonicalize/3","title":"XmerlC14n.canonicalize/3","type":"function","doc":""},{"ref":"XmerlC14n.html#canonicalize!/1","title":"XmerlC14n.canonicalize!/1","type":"function","doc":"Given an xmerl XML tuple (element/attribute/etc...), returns the canonical binary version of the XML it represents. Returns either String.t() if canonicalized successfully, or raises an ArgumentError if canonicalization failed. If the preserve_comments argument is true, preserves comments in the output. Any namespace prefixes listed in inclusive_namespaces will be left as they are and not modified during canonicalization. # Given xml &lt;!DOCTYPE doc [&lt;!ATTLIST e9 attr CDATA &quot;default&quot;&gt;]&gt; &lt;doc&gt; &lt;e1 /&gt; &lt;e2 &gt;&lt;/e2&gt; &lt;e3 name = &quot;elem3&quot; id=&quot;elem3&quot; /&gt; &lt;e4 name=&quot;elem4&quot; id=&quot;elem4&quot; &gt;&lt;/e4&gt; &lt;e5 a:attr=&quot;out&quot; b:attr=&quot;sorted&quot; attr2=&quot;all&quot; attr=&quot;I&#39;m&quot; xmlns:b=&quot;http://www.ietf.org&quot; xmlns:a=&quot;http://www.w3.org&quot; xmlns=&quot;http://example.org&quot;/&gt; &lt;e6 xmlns=&quot;&quot; xmlns:a=&quot;http://www.w3.org&quot;&gt; &lt;e7 xmlns=&quot;http://www.ietf.org&quot;&gt; &lt;e8 xmlns=&quot;&quot; xmlns:a=&quot;http://www.w3.org&quot;&gt; &lt;e9 xmlns=&quot;&quot; xmlns:a=&quot;http://www.ietf.org&quot;/&gt; &lt;/e8&gt; &lt;/e7&gt; &lt;/e6&gt; &lt;/doc&gt; iex&gt; {doc, _} = xml |&gt; to_charlist |&gt; :xmerl_scan.string(namespace_conformant: true, document: true) iex&gt; XmerlC14n.canonicalize!(doc) |&gt; IO.puts &lt;doc&gt; &lt;e1&gt;&lt;/e1&gt; &lt;e2&gt;&lt;/e2&gt; &lt;e3 id=&quot;elem3&quot; name=&quot;elem3&quot;&gt;&lt;/e3&gt; &lt;e4 id=&quot;elem4&quot; name=&quot;elem4&quot;&gt;&lt;/e4&gt; &lt;e5 xmlns=&quot;http://example.org&quot; xmlns:a=&quot;http://www.w3.org&quot; xmlns:b=&quot;http://www.ietf.org&quot; attr=&quot;I&#39;m&quot; attr2=&quot;all&quot; b:attr=&quot;sorted&quot; a:attr=&quot;out&quot;&gt;&lt;/e5&gt; &lt;e6&gt; &lt;e7 xmlns=&quot;http://www.ietf.org&quot;&gt; &lt;e8 xmlns=&quot;&quot;&gt; &lt;e9&gt;&lt;/e9&gt; &lt;/e8&gt; &lt;/e7&gt; &lt;/e6&gt; &lt;/doc&gt;"},{"ref":"XmerlC14n.html#canonicalize!/2","title":"XmerlC14n.canonicalize!/2","type":"function","doc":""},{"ref":"XmerlC14n.html#canonicalize!/3","title":"XmerlC14n.canonicalize!/3","type":"function","doc":""}]